#include <iostream>
#include <cstdio>
using namespace std;
int n; double a[100];
int main(){
	freopen("test.in", "r", stdin);
	freopen("test.out", "w", stdout);
	scanf("%d", &n);
	for(int i = 1; i <= n; i++){
		int x; scanf("%d", &x);
		a[i] = x;
	}
	for(int i = 1; i <= n; i++)
		printf("%-15.5lf", a[i]);
	printf("\n");
	for(int r = 1; r <= 2*n; r++){
		for(int i = 1; i <= n; i++)
			a[i] += a[n-i+1];
		for(int i = n; i >= 1; i--)
			a[i] = a[(i+1)/2] / 2.0;
		for(int i = 1; i <= n; i++)
			printf("%-15.5lf", a[i]);
		printf("\n");
	}
	fclose(stdin);
	fclose(stdout);
	return 0;
}
